/* ----------------------------------------------
	Nyisztor Kroly
	Shader programozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: AmbientDiffuse.fx
	Lers	: Terjed fnyvisszaverds
	Lsd	: 11.6.2. "Terjed, diffz fnyvisszaverods"
			  327. oldal
------------------------------------------------- */

uniform extern float4x4 gWorld;
uniform extern float4x4 gWorldViewProjection;
uniform extern float4 gAmbientMaterialColor;
uniform extern float4 gDiffuseMaterialColor;
uniform extern float4 gLightColor;
uniform extern float3 gLightPos;
 
struct VS_OUTPUT
{
    float4 PositionProj : POSITION0;
    float4 VertexColor	: COLOR0;
};
// cscspont rnyal
VS_OUTPUT vs_main(float3 posLocal_in : POSITION0, float3 normalLocal_in : NORMAL0)
{
    // eredmny struktra kinullzsa
	VS_OUTPUT outVS = (VS_OUTPUT)0;
	
	// felleti normlvektor transzformlsa modelltrbl a vilg-koordintarendszerbe
	float3 normalWorld = mul(float4(normalLocal_in, 0.0f), gWorld).xyz;
	normalWorld = normalize(normalWorld);

	// cscspont helyzetnek transzformcija vilgkoordinta-rendszerbe
	float3 posW = mul(float4(posLocal_in, 1.0f), gWorld).xyz;

	// fnyvektor kiszmtsa
	float3 lightVecW = normalize( gLightPos - posW );
	
	// fnyintenzits kiszmtsa a Lambert-fle koszinusz fggvnnyel
	float i_diffuse = max(dot(lightVecW, normalWorld), 0.0f);
	// a diffz szn kiszmtsa
	float3 diffuseColor = i_diffuse * ( gDiffuseMaterialColor * gLightColor).rgb;
	// kimeneti struktra feltltse
	outVS.VertexColor.rgb = gAmbientMaterialColor + diffuseColor;
	outVS.VertexColor.a   = gDiffuseMaterialColor.a;
	
	// cscspont helyzet transzformci vgrehajtsa
	outVS.PositionProj = mul(float4(posLocal_in, 1.0f), gWorldViewProjection);
	
	// a kitlttt struktra visszatrtse
    return outVS;
}
// kppont rnyal
float4 ps_main(float4 color_in : COLOR0) : COLOR
{
    return color_in;
}

technique AmbientDiffuseTech
{
    pass P0
    {
        // a P0 lps cscspont- s kppontrnyalja
        vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}
