#if !defined( CINPUT_H )
#define CINPUT_H
/*[ Fordtsi egysg ----------------------------------------------------------
    Nv               : CInput.h

    Nyelv             : C++

    Ltrehozs dtuma : 2008.03.24

    Utols mdosts  : 2008.04.10

    Lers            : CInput homlokzat osztly

               Copyright (C) Nyisztor Kroly 2008-2009
-----------------------------------------------------------------------------*/

/*- Nvterek ----------------------------------------------------------------*/
namespace app
{
namespace input
{

/*- Defincik s konstansok ------------------------------------------------*/
#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

// makr a singleton osztly hasznlatra 
#define INPUT (CInput::Instance())

class CInput
{
public:
	static CInput* Instance();
	
	~CInput();

	void update();
	bool isKeyDown(char key);
	bool isMouseButtonDown(int button);
	float getMouseDX();
	float getMouseDY();
	float getMouseDZ();

private:
	// ctor, msol ctor s rtkad opertor elrejtse
	CInput( HWND winHandle_in, HINSTANCE appInstance_in, DWORD keyboardFlags, DWORD mouseFlags );
	CInput(const CInput& rhs);
	CInput& operator=(const CInput& rhs);
	
	void CInput::setMouseRange( RECT& rect );
		
private:
	IDirectInput8*       myDirectInputPtr;

	IDirectInputDevice8* myKeyboardPtr;
	
	char                 myKeyboardState[256]; 

	IDirectInputDevice8* myMousePtr;
	
	DIMOUSESTATE2        myMouseState;
};
}
}
#endif // CINPUT_H